$ save_verify = 'f$verify(0)'
$!
$! This procedure links the http_base_mst shareable image from the object files.
$!
$! Parameters:
$!
$! Author:	David Jones
$! Date:	6-DEC-1997
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! First validate P1.
$ say = "WRITE SYS$OUTPUT"
$ create TMP_LINK.OPT
$ open/append lopt TMP_LINK.OPT
$ on error then goto cleanup
$ on control_y then goto cleanup
$!
$! Determine our configuration.
$!
$ is_axp = (f$getsyi("CPU") .ge. 128)
$ is_vaxc = (.not.is_axp .and. (f$trnlnm("DECC$CC_DEFAULT") .nes. "/DECC"))
$ is_vmsv5 = ("V5." .eqs. f$extract(0,3,f$getsyi("VERSION")))
$ write lopt "!This file generated by LINK_TCPSHARE.COM, AXP flag: ", is_axp, -
	", VAXC flag: ", is_vaxc, ", TCP: ", P1
$!
$! Start with base files.
$!
$ if is_axp
$ then
$!	Make symbol vector
$    close lopt
$    append base_mst.opt tmp_link.opt
$    open/append lopt tmp_link.opt
$ else
$!	Use macro transfer vector.
$     gosub make_transvec
$    write lopt "file_access.obj,fast_utc.obj,message_service.obj"
$    write lopt "mst_share.obj,tutil.obj,tmemory.obj,file_cache.obj,data_cache.obj"
$    write lopt "transvec.obj"
$!
$    write lopt "CLUSTER=FIRST,,,"		! make vect first in image
$    write lopt "COLLECT=FIRST,$$XGBL,$$XVEC
$    if is_vmsv5 then write lopt "DZRO_MIN=32"
$    write lopt "GSMATCH=LEQUAL,3,2"	! VAX linkage
$    write lopt "IDENTIFICATION=""MST 3.2"""
$ endif
$!
$! Add Pthreads libraries.
$ write lopt "sys$share:cma$lib_shr/share,cma$rtl/share
$ if is_axp then write lopt "sys$share:cma$open_lib_shr/share,cma$open_rtl/share
$!
$! Add special stuff for VAXC
$!
$ if is_vaxc then write lopt "sys$share:vaxcrtl/share"
$ if is_vaxc then write lopt "PSECT_ATTR=$CHAR_STRING_CONSTANTS,NOWRT"
$ if is_vaxc then write lopt "PSECT_ATTR=HTTP_REENTRANT_C_RTL,NOSHR"
$ if is_vaxc then write lopt "PSECT_ATTR=HTTP_REENTRANT_VMS_RTL,NOSHR"
$ if is_vaxc then write lopt "PSECT_ATTR=HTTP_MST_DATA,NOSHR"
$!
$ close lopt
$ on error then exit $status
$ purge tmp_link.opt
$!
$ if P3 .nes. "" then P3 = p3 + ","
$ link/share=http_base_mst.exe/map=http_base_mst.map 'P2' 'P3'TMP_LINK.OPT/OPT
$ copy http_base_mst.exe [-.system]/log
$ save_verify = f$verify(save_verify)
$ exit $status
$!
$ cleanup:
$ close lopt
$ save_verify = f$verify(save_verify)
$ exit
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ make_transvec:
$ macro/object=sys$disk:[]transvec.obj sys$input
; Threaded tcp server transfer vector.
;
; Under
;
; define macro to make transfer vector entry for a given routine.  Entry mask 
; is obtained from routine we are transfering to.  Jump to word past entry 
; since these are VAX procedures.
;
	.MACRO TRANSFER_ENTRY routine
;
	.TRANSFER routine
	.MASK	  routine
	JMP	  routine + 2
;
	.ENDM TRANSFER_ENTRY
;
	.TITLE BASE_MST_VECTOR
	.IDENT /01/
;
;	Make 1 page for shared globals.
;
	.PSECT $$XGBL PIC,USR,CON,REL,GBL,NOSHR,NOEXE,RD,WRT,NOVEC
ts_gbl:
HTTP_BASE_MST_GLOBALS::
.transfer  HTTP_BASE_MST_GLOBALS
HTTP_LOG_LEVEL::
	.long 0				; log/trace level
TLOG_PUTLOG_CB::
	.long 0				; Address of putlog routine.
HTTP_REENTRANT_C_RTL::
	.long 0				; if non-zero, RTL is reentrant
HTTP_REENTRANT_VMS_RTL::
	.long 0
	.blkb 512-<.-ts_gbl>

	.PSECT $$XVEC PIC,USR,CON,REL,LCL,SHR,EXE,RD,NOWRT,NOVEC
;
;	simply go through shared procedures and declare transfer vector
;	entry points for them.  
;
ts_xfer:
	.transfer HTTP_BASE_MST_GLOBALS_P
HTTP_BASE_MST_GLOBALS_P::
	.address HTTP_BASE_MST_GLOBALS
	.address TLOG_PUTLOG_CB			; spare entry.
	TRANSFER_ENTRY tf_initialize
	TRANSFER_ENTRY tf_open
	TRANSFER_ENTRY tf_read
	TRANSFER_ENTRY tf_close
	TRANSFER_ENTRY tf_last_error
	TRANSFER_ENTRY tf_getline
	TRANSFER_ENTRY tf_header_info
	TRANSFER_ENTRY tf_format_time
	TRANSFER_ENTRY tf_decode_time
	TRANSFER_ENTRY tf_isdir
	TRANSFER_ENTRY tf_at_eof
	TRANSFER_ENTRY tf_set_crlf_newline
	TRANSFER_ENTRY futc_initialize
	TRANSFER_ENTRY futc_local_to_gmt
	TRANSFER_ENTRY futc_current_time
	TRANSFER_ENTRY futc_decode_vms_date
	TRANSFER_ENTRY futc_vms_time
	TRANSFER_ENTRY futc_test_cache
	TRANSFER_ENTRY futc_update_cache
	TRANSFER_ENTRY mstshr_init
	TRANSFER_ENTRY mstshr_cgi_symbols
	TRANSFER_ENTRY mstshr_cgi_symbols2
	TRANSFER_ENTRY mstshr_getenv
	TRANSFER_ENTRY mst_create_service_pool
	TRANSFER_ENTRY mst_register_service
	TRANSFER_ENTRY mst_connect
	TRANSFER_ENTRY mst_read
	TRANSFER_ENTRY mst_write
	TRANSFER_ENTRY mst_close
	TRANSFER_ENTRY mst_exit
	TRANSFER_ENTRY mst_format_error
	TRANSFER_ENTRY mst_usage_limits
	TRANSFER_ENTRY tm_initialize
	TRANSFER_ENTRY tm_malloc
	TRANSFER_ENTRY tm_free
	TRANSFER_ENTRY tm_calloc
	TRANSFER_ENTRY tm_realloc
	TRANSFER_ENTRY tm_create_heap
	TRANSFER_ENTRY tm_destroy_heap
	TRANSFER_ENTRY tm_change_heap
	TRANSFER_ENTRY tfc_init
	TRANSFER_ENTRY tfc_cached_open
	TRANSFER_ENTRY tfc_rundown_context
	TRANSFER_ENTRY tfc_get
	TRANSFER_ENTRY tfc_put
	TRANSFER_ENTRY tfc_expire_all
	TRANSFER_ENTRY tfc_display_counters
	TRANSFER_ENTRY tfc_display_entries
	TRANSFER_ENTRY tfc_mark_port_number
	TRANSFER_ENTRY tfc_test_port_number
	TRANSFER_ENTRY tcache_set_max_recsize
;
;	allocate extra space to allow for code modifications without changing 
;	the size of the shared image.
;
	.BLKB 1024-<.-ts_xfer>		; reserve rest of page for future
;
	.END
$ RETURN
