$! Script interface to analog program, place this file in the [.bin]
$! directory and analog.exe in  www_system (avoids mischief caused by
$! users trying to run /htbin/analog.exe
$!
$ crlf = f$fao("!/")
$ net_write = "write net_link"
$ net_write "<DNETRECMODE>"
$ cgi_symbols www_ form_
$ set noverify
$ if www_request_method .eqs. "GET" .or. www_request_method .eqs. "HEAD"
$ then
$!    send back form.
$!
$     create net_link:
Content-type: text/html

<HTML><HEAD><TITLE>Analog form</TITLE></HEAD><BODY>
<H2>Analog log analysis program</H2>
<FORM method="POST" action="analog.com">
Log file: <TT>www_system:access.log</TT></P>
Report type: <select name="defopt"><option selected>  brief
<option> full<option> custom</select><P>
<DL><DT>Custom settings (only apply if report type is custom)</DT><DD>
<input type="checkbox" name="general">General statistics<BR>
<input type="checkbox" name="monthly">Show month report<BR>
<input type="checkbox" name="weekly">Show week report<BR>
<input type="checkbox" name="daily">Show daily summary (day of week)<BR>
<input type="checkbox" name="day">Show daily report (day of month)<BR>
<input type="checkbox" name="hourly">Show hourly summary<BR>
<input type="checkbox" name="hours">Show hourly report<BR>
<input type="checkbox" name="domain">Show domain report<BR>
<input type="checkbox" name="host">Show host report<BR>
<input type="checkbox" name="directory">Show directory report<BR>
<input type="checkbox" name="ftype">Show file type report<BR>
<input type="checkbox" name="request">Show request report<BR>
<input type="checkbox" name="referrer">Show referrer report<BR>
<input type="checkbox" name="browsum">Show browser summary<BR>
<input type="checkbox" name="browser">Show browser report<BR>
<input type="checkbox" name="scode">Show status code report<BR>
<input type="checkbox" name="ecode">Show error report<BR>
</DD></DL>
<P>
<DL><DT>Display Options:</DT><DD>
<input type="checkbox" value="on" name="sevenday">Include 7-day stats<BR>
<input type="checkbox" name="dnslookup">Translate host addresses<BR>
<input type="checkbox" name="verify">Verify settings<BR>
</DD></DL>
<input type="submit" value=" analyze ">  <input type="reset" value = " clear ">
</FORM> 
<HR>
The HTML to generate this page as well as the default configuration
file used by ANALOG are embedded in the analog.com script.
</BODY></HTML>
$   exit
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ else
$    !
$    ! Interpret submitted fields.
$    !
$    opt_list = ""
$    if f$type(form_fld_defopt) .eqs. "" then form_fld_defopt = "custom"
$    def_opt = " ""-A"""  	! custom report
$    if form_fld_defopt .eqs. "full" then def_opt = " ""+A"""
$    if form_fld_defopt .eqs. "brief" then -
	def_opt = """-A"" "
$    opt_list = opt_list + def_opt
$    sv_verify = f$verify(0)
$!
$    flag_set = "7/sevenday,1/dnslookup"
$    gosub scan_flags
$!
$    if def_opt .nes. " ""-A""" then goto analyze_log
$!
$    flag_set = "x/general,m/monthly,h/hourly,H/hours,W/weekly,d/daily,D/day,"-
       + "o/domain,S/host,i/directory,r/request,t/ftype,f/referrer," -
       + "b/browsum,B/browser,c/scode,e/ecode"
$    gosub scan_flags
$    sv_verify = f$verify(sv_verify)
$!
$ analyze_log:
$ set verify=(procedure,noimage)
$    if ( f$type(form_fld_verify) .eqs. "" ) then form_fld_verify = "off"
$    if form_fld_verify .eqs. "on" 
$    then 
$	opt_list = "-v " + opt_list
$       define/user sys$Output net_link:
$       write net_link "Content-type: text/plain",f$fao("!/")
$    else
$        write net_link "Content-type: text/html",f$fao("!/")
$    endif
$!
$!   Invoke with configuration settings.
$!
$    mcr www_system:analog.exe "-G" +g- 'opt_list'
#
#  Make default settings to override all options in analhead.h
#
HOSTNAME	"Koffolt Computer Graphics Lab"
HOSTURL		http://kcgl1.eng.ohio-state.edu/
DOMAINSFILE	www_system:domains.tab
LOGFILE		www_system:access.log
IMAGEDIR	/demo/images/
LOGOURL		/demo/images/analogo.gif
OUTFILE		net_link:
CACHEFILE	none
NUMLOOKUP	OFF
DNSFILE		www_system:dnscache.dat
CASE		INSENSITIVE
#
# Set which stats each report type shows.
DOMCOLS		Rb
HOSTCOLS	Rb
DIRCOLS		Rb
TYPECOLS	Rb
REQCOLS		Rb
MONTHCOLS	R
DAYCOLS		R
FULLDAYCOLS	R
WEEKCOLS	R
HOURCOLS	R
FULLHOURCOLS	R
REFCOLS		Rb
BROWCOLS	Rb
FULLBROWCOLS	Rb
#
#  Graph columns
MONTHGRAPH	R
DAYGRAPH	R
FULLDAYGRAPH	R
HOURGRAPH	R
FULLHOURGRAPH	R
WEEKGRAPH	R
#
# row maximums (0 for unlimited)
MONTHROWS	0
WEEKROWS	0
FULLDAYROWS	42
FULLHOURROWS	72

GRAPHICAL	ON		# whether to include graphics images.
$ endif
$ exit
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! subroutine tobuild def_opt string:
$!  input:
$!     flag_set	comma-separated list of flag/field-name pairs.
$!  output
$!	opt_list
$!
$ scan_flags:
$ i = 0
$ next_flag:
$    flag_pair = f$element(i,",",flag_set)
$    if flag_pair .eqs. "," then return
$    flag = f$element(0,"/",flag_pair)
$    quote = ""
$    if flag .eqs. f$edit(flag,"upcase") then quote = """"
$    fld_name = f$element(1,"/",flag_pair)
$    if f$type(form_fld_'fld_name') .eqs. "" then form_fld_'fld_name' = "off"
$    flag_val = f$edit(form_fld_'fld_name',"UPCASE")
$    if flag_val .eqs. "ON" .or. flag_val .eqs. "1"
$    then
$	opt_list = opt_list + " " + quote + "+" + flag + quote
$    else
$	opt_list = opt_list + " " + quote + "-" + flag + quote
$    endif
$    i = i + 1
$     goto next_flag
