$ save_verify = f$verify(f$integer("0"+f$trnlnm("www_mbxnet_verify")))
$!
$! Define www_root as this procedure's parent directory if not defined otherwise.
$ set output=00:00:05
$ if f$trnlnm("WWW_ROOT") .eqs. ""
$ then
$    root_dir = f$parse("1.;",f$environment("PROCEDURE"),,, -
	"NO_CONCEAL,SYNTAX_ONLY") - "][" - "]1.;" + "]"
$    l = f$length(root_dir)
$ trim_last:
$    l = l - 1
$    if f$extract(l,1,root_dir) .nes. "." .and. l .gt. 0 then goto trim_last
$    root_dir = f$extract(0,l,root_dir) + ".]"
$    write sys$output "Defining www_root as ", root_dir
$    define www_root 'root_dir'/translation=(terminal,concealed)
$ endif
$ if f$trnlnm("WWW_SYSTEM") .eqs. "" then define www_system www_root:[system]
$!
$ count = 0
$ set noon
$ next_client:
$ run mbxnet_server		! will call wwwexec on exit.
$ if .not. $status then exit
$ count = count + 1
$ if count .lt. 25 then goto next_client
$ write sys$output "Creating new log file"
$ deass sys$Output
$ define sys$output mbxnet_log_chan
$ count = 0
$ goto next_client
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ wwwexec: subroutine
$!
$ read_net = "read/end=done net_link"
$ write_net = "write net_link"
$ wwwexec_rundown_string == ""
$!
$! Connect to partner (HTTP server) and read input parameters.
$!
$ open/read/write net_link 'p1'
$ on error then goto wwwexec_cleanup
$ read_net subfunc		! Sub-function (SEARCH, HTBIN)
$ read_net method		! HTTP request method field
$ read_net protocol		! Protocol field in HTTP request
$ read_net url			! 'file' part of URL in HTTP request.
$!
$! Dispatch on subfunc value.  We expect HTBIN to be most common case, so
$! check for it first.
$!
$ offset = f$locate(subfunc+",","HTBIN,SEARCH,CONVERT,POST,")
$ on warning then goto done		! Make DCL symbol errors abort us.
$ if  offset .LT. 26 then goto do_'subfunc'
$ do_error:
$! Generate error response for unknown sub function.
$ call send_sts "500 server error" "Internal error in server, unsupported function.
$ goto  done_1
$!------------------------------------------------------------------------
$! Script execution.  Parse script name out of URL and search for it in
$! htbin directory, constructing execution symbol in process.
$!
$ do_htbin:
$ write_net "<DNETPATH>"
$ read_net script_path
$ script_name = f$element(0,"/",url-script_path)
$ write_net "<DNETBINDIR>"
$ read_net http_bindir
$!
$! Construct symbol to execute script, either as foreign command or DCL proc.
$!
$ script_exec = "$" + f$element(0,";",f$search(f$parse(http_bindir+script_name,".com")))
$ if script_exec .eqs. "$" then script_exec = "$" + -
	f$element(0,";",f$search(f$parse(http_bindir+script_name,".exe")))
$ stype = f$parse(script_exec-"$",,,"TYPE")
$ if stype .eqs. ".COM" then script_exec[0,1] := "@"
$ if stype .eqs. ".PL" then goto Perl_script
$ if ( script_exec .nes. "$" )
$ then
$    cgi_symbols = "$"+http_bindir+"cgi_symbols.exe"
$    on warning then goto done
$    script_exec "''method'" "''url'" "''protocol'"
$ else
$    call send_sts "404 script not found" -
	"''f$fao("Requested script (!AS) not found in htbin directory (!AS)",-
	script_name,http_bindir)'"
$ endif
$ goto done_1
$ perl_script:
$   write_net "<DNETRECMODE>"
$   tfile = "sys$scratch:perlcgi_" + f$string(f$getjpi("0","PID")) + ".tmp"
$   on warning then goto perl_done
$   create/name_table cgi_env		! holds environment logicals.
$   p1 = method 
$   p2 = url
$   p3 = protocol
$   mcr 'http_bindir'cgi_symbols.exe cgi_env "''tfile'"
$   if f$integer("0"+f$trnlnm("CONTENT_LENGTH","CGI_ENV")) .le. 0 then tfile = "_NL:"
$   if f$type(perl) .eqs. "" then perl = "$www_system:miniperl"
$   on warning then goto done
$   define/user sys$output net_link:
$   define/user sys$intput 'tfile'
$   define/user/table=lnm$process_directory lnm$file_dev cgi_env, -
	lnm$process, lnm$job, lnm$group, lnm$system, decw$logical_names
$   perl 'f$extract(1,255,script_exec)' "''method'" "''protocol'" >net_link: <'tfile'
$   perl_done:
$   set noon
$   deassign/table=lnm$process_directory CGI_ENV
$   if tfile .neqs. "_NL:" then delete 'tfile';*
$   goto done_1
$!
$!------------------------------------------------------------------------
$! Post command.
$!
$ do_post2:
$ write sys$Output "Saving request..."
$ mcr sys$login:request_to_file net_link wwwexec.tmp
$ call send_sts "200 ok" "Request has been saved to file wwwexec.tmp"
$ goto done_1
$!
$!------------------------------------------------------------------------
$! Mime types defined by presentation rules in config file will cause 
$! convert sub-function to be used, search arguments cause search subfunction.
$! The bindir argument is assumed to be the name of the script to execute.
$ do_convert:
$ do_search:
$ do_post:
$ write_net "<DNETBINDIR>"
$ read_net script_name
$ script_exec = "$" + f$search(f$parse(script_name,"WWW_SYSTEM:.com"))
$ if script_exec .eqs. "$" then script_exec = "$" + -
	f$element(0,";",f$search(f$parse(script_name,"WWW_SYSTEM:.exe")))
$ if f$parse(script_exec-"$",,,"TYPE") .eqs. ".COM" then script_exec[0,1] := "@"
$!
$ if ( script_exec .nes. "$" )
$ then
$!
$!   Run the script as foriegn command or command procedure.
$!
$    cgi_symbols = "$"+f$parse("cgi_symbols.exe;",f$extract(1,256,script_exec))-";"
$    on warning then goto done
$    script_exec "''method'" "''url'" "''protocol'"
$ else
$    call send_sts "404 presentation script not found" -
	"''f$fao("!AS program (!AS) not found.",subfunc,script_name)
$ endif
$!
$!------------------------------------------------------------------------
$! Common exit point.  Clean up connection.
$!
$ done_1:
$ if wwwexec_rundown_string .nes. "" then write_net wwwexec_rundown_string
$ read_net /time_out=10 line		! let server break connection first.
$ done:
$ deass sys$output
$ wwwexec_cleanup:
$ close net_link
$ exit $status
$ endsubroutine
$!--------------------------------------------------------------------------
$! Common procedure to send messages to.
$! Parameters are: P1: status, P2: text.
$!
$ send_sts: SUBROUTINE
$ set noon
$ write_net "<DNETTEXT>"
$ write_net P1
$ write_net P2
$ write_net "</DNETTEXT>"
$ endsubroutine
