$!  This command procedure is a customized WWWEXEC.COM for supporting
$!  user script directories.  To configure, add the following line
$!  to your (http_scripts.conf) configuration file:
$!
$!	exec /htbin~* 0"altuser"::"0=WWWUEXEC"bin
$!
$!  where:
$!	altuser     Alternate user account set up from which to run
$!     		    user scripts.  Set up a proxy from the server account
$!		    to the alternate account.
$!	bin	    Sub-directory name for the user scripts (e.g. "bin"),
$!		    this is a sub-directory of the web directory.
$!!!!!!!!!!
$! Define www_root as procedure's directory if not defined otherwise.
$ if f$trnlnm("WWW_ROOT") .eqs. ""
$ then
$    root_dir = f$parse("1.;",f$environment("PROCEDURE"),,, -
	"NO_CONCEAL,SYNTAX_ONLY") - "][" - "]1.;" + ".]"
$    define www_root 'root_dir'/translation=(terminal,concealed)
$ endif
$ if f$trnlnm("WWW_SYSTEM") .eqs. "" then define www_system www_root:[system]
$ read_net = "read/end=done net_link"
$ write_net = "write net_link"
$ wwwexec_rundown_string == ""
$!
$! Connect to partner (HTTP server) and read input parameters.
$!
$ open/read/write net_link sys$net
$ read_net subfunc		! Sub-function (SEARCH, HTBIN)
$ read_net method		! HTTP request method field
$ read_net protocol		! Protocol field in HTTP request
$ read_net url			! 'file' part of URL in HTTP request.
$ if f$locate("""",url) .lt. f$length(url) then gosub dquote_url
$!
$! Dispatch on subfunc value.  We expect HTBIN to be most common case, so
$! check for it first.
$!
$ offset = f$locate(subfunc+",","HTBIN,SEARCH,CONVERT,POST,")
$ on warning then goto done		! Make DCL symbol errors abort us.
$ if  offset .LT. 26 then goto do_'subfunc'
$ do_error:
$! Generate error response for unknown sub function.
$ call send_sts "500 server error" "Internal error in server, unsupported function."
$ goto  done_1
$!------------------------------------------------------------------------
$! Script execution.  Parse script name out of URL and search for it in
$! htbin directory, constructing execution symbol in process.
$!
$ do_htbin:
$ write_net "<DNETPATH>"
$ read_net script_path
$ write_net "<DNETBINDIR>"
$ read_net http_bindir
$ if f$locate("~",script_path) .lt. f$length(script_path)
$ then
$     script_user = f$element(0,"/",url-script_path)
$     script_name = f$element(1,"/",url-script_path)
$     write_net "<DNETXLATE>"
$     write_net "/~"+script_user
$     read_net user_dir
$     gosub convert_bindir		! redo http_bindir
$ else
$    script_user = ""
$    script_name = f$element(1,"/",url-script_path)
$ endif
$!
$! Construct symbol to execute script, either as foreign command or DCL proc.
$!
$ script_exec = "$" + f$element(0,";",f$search(f$parse(http_bindir+script_name,".com")))
$ if script_exec .eqs. "$" then script_exec = "$" + -
	f$element(0,";",f$search(f$parse(http_bindir+script_name,".exe")))
$ stype = f$parse(script_exec-"$",,,"TYPE")
$ if stype .eqs. ".COM" then script_exec[0,1] := "@"
$ if stype .eqs. ".PL" then goto Perl_script
$ if ( script_exec .nes. "$" )
$ then
$    cgi_symbols = "$WWW_ROOT:[BIN]cgi_symbols.exe"-"..."
$    on warning then goto done
$    script_exec "''method'" "''url'" "''protocol'"
$ else
$    call send_sts "404 script not found" -
	"''f$fao("Requested script (!AS) not found in htbin directory (!AS)",-
	script_name,http_bindir)'"
$ endif
$ goto done_1
$ perl_script:
$   tfile = "sys$scratch:perlcgi_" + f$string(f$getjpi("0","PID")) + ".tmp"
$   write_net "<DNETRECMODE>"
$   on warning then goto perl_done
$   create/name_table cgi_env		! holds environment logicals.
$   p1 = method 
$   p2 = url
$   p3 = protocol
$   http_bindir = http_bindir-"..."
$   mcr www_root:[bin]cgi_symbols.exe cgi_env "''tfile'"
$   if f$integer("0"+f$trnlnm("CONTENT_LENGTH","CGI_ENV")) .le. 0 then tfile = "_NL:"
$   if f$type(perl) .eqs. "" then perl = "$www_system:miniperl"
$   define/user/table=lnm$process_directory lnm$file_dev cgi_env, -
	lnm$process, lnm$job, lnm$group, lnm$system, decw$logical_names
$   perl 'f$extract(1,255,script_exec)' "''method'" "''protocol'" >net_link: <'tfile'
$   perl_done:
$   set noon
$   deassign/table=lnm$process_directory CGI_ENV
$   if tfile .nes. "_NL:" then delete 'tfile';*
$   goto done_1
$!
$ convert_bindir:
$   if user_dir .eqs. ""
$   then
$	call send_sts "400 Invalid User specified" "Invalid/missing username"
$	goto done_1
$   endif
$   dev = f$element(1,"/",user_dir)
$   dlist = f$element(2,"/",user_dir)
$   enum = 3
$   next_ud:
$	elem = f$element(enum,"/",user_dir)
$       if elem .eqs. "/"
$	then
$	   http_bindir = dev + ":[" + dlist + "." + http_bindir + "]"
$	   show symbol http_bindir
$	   return
$	endif
$	dlist = dlist + "." + elem
$       enum = enum + 1
$	goto next_ud
$!
$!------------------------------------------------------------------------
$! Mime types defined by presentation rules in config file will cause 
$! convert sub-function to be used, search arguments cause search subfunction.
$! The bindir argument is assumed to be the name of the script to execute.
$ do_convert:
$ do_search:
$ do_post:
$ write_net "<DNETBINDIR>"
$ read_net script_name
$ sho symbol script_name
$ script_exec = "$" + f$element(0,";",f$search(f$parse(script_name,"WWW_SYSTEM:.com")))
$ if script_exec .eqs. "$" then script_exec = "$" + -
	f$element(0,";",f$search(f$parse(script_name,"WWW_SYSTEM:.exe")))
$ if f$parse(script_exec-"$",,,"TYPE") .eqs. ".COM" then script_exec[0,1] := "@"
$!
$ if ( script_exec .nes. "$" )
$ then
$!
$!   Run the script as foriegn command or command procedure.
$!
$    cgi_symbols = "$"+f$parse("cgi_symbols.exe;",f$extract(1,256,script_exec))-";"
$    on warning then goto done
$    script_exec "''method'" "''url'" "''protocol'"
$ else
$    call send_sts "404 presentation script not found" -
	"''f$fao("!AS program (!AS) not found.",subfunc,script_name)
$ endif
$ goto done_1
$!
$!------------------------------------------------------------------------
$! Common exit point.  Clean up connection.
$!
$ done_1:
$ if wwwexec_rundown_string .nes. "" then write_net wwwexec_rundown_string
$ read_net /time_out=10 line		! let server break connection first.
$ done:
$ deass sys$output
$ close net_link
$ exit $status
$!--------------------------------------------------------------------------
$! Common procedure to send messages to.
$! Parameters are: P1: status, P2: text.
$!
$ send_sts: SUBROUTINE
$ set noon
$ write_net "<DNETTEXT>"
$ write_net P1
$ write_net P2
$ write_net "</DNETTEXT>"
$ endsubroutine
$!-----------------------------------------------------------------------------
$! reconstruct url symbols with quotes doubled.
$!
$ dquote_url:
$ i = 0
$ orig_url = url
$ url = f$element(0,"""",orig_url)
$ next_dquote:
$   i = i + 1
$   part = f$element(i,"""",orig_url)
$   if ( part .eqs. """" ) then return
$   url = url + """""" + part
$   goto next_dquote
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
